
// ECAT-M801-DEMODlg.h : Y
//

#pragma once
#include "afxwin.h"
#include <stdint.h>
#include "EcatDeviceAPI.h"
#include "EcatErrno.h"
#include "afxcmn.h"
#define timeout 3
#define DEV_TIMER_CYCLE_TIME 30 //ms

typedef struct ecat_2011h_t //V0
{
	unsigned int Underrange		: 1;
	unsigned int Overrange		: 1;
	unsigned int Limit1			: 2;
	unsigned int Limit2			: 2;
	unsigned int Error			: 1;
	unsigned int Gap1			: 1;
	unsigned int Gap2			: 6;
	unsigned int TxPDO_State	: 1;
	unsigned int TxPDO_Toggle	: 1;
	unsigned int Value			:16;
}ecat_2011h_st;

typedef struct ecat_2028_t //VOUT0
{
	unsigned int Output			:16;
	unsigned int Gap			:16;
}ecat_2028_st;

typedef struct ecat_event
{
	uint16_t DeviceNo;
	uint16_t EventID;
}ecat_event_st;

// CECATM801DEMODlg ܤ
class CECATM801DEMODlg : public CDialog
{
// غc
public:
	CECATM801DEMODlg(CWnd* pParent = NULL);	// зǫغc禡

// ܤ
	enum { IDD = IDD_ECATM801DEMO_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 䴩


// {X@
protected:
	HICON m_hIcon;

	// ͪT禡
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	uint16_t DeviceNo;
	clock_t startTime;
	bool isOP;
	ecat_event_st EcatEvent;

	ecat_2011h_st ecat_2011h;//Data type of the module 
	ecat_2028_st ecat_2028;
	uint32_t ecat_2051_32_value;
	uint32_t ecat_2045_32_value;

	uint16_t ecat_2011h_SlaveNo; // The position of the module in the ethercat network
	uint16_t ecat_2028_SlaveNo;
	uint16_t ecat_2051_SlaveNo;
	uint16_t ecat_2045_SlaveNo;

	double ecat_2011h_Scale; // Scale RawData to Volt/mA
	double ecat_2028_Scale; // Scale RawData to Volt

	CEdit WgLblSlavesResp;	//The number of modules in a network
	CEdit WgLblAlStates;	//Al state of ethercat master
	CEdit WgLblWc;			//working counter of ethercat master
	CEdit WgLblLinkUp;		//Network link status of EtherCAT
	CEdit WgLblstate;
	CListCtrl WgSlaveList;

	CEdit WgE2011H_IN;
	CEdit WgE2028_SET;
	CEdit WgE2028_OUT;
	CEdit WgE2051_IN;
	CEdit WgE2045_SET;
	CEdit WgE2045_OUT;

	void InitConsole();
	int InitDevice();
	int Opendevice();
	int InitModules();
	int InitEvent();
	int Startoptask();
	void ModuleProcess();
	

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnClose();
	afx_msg void OnBnClickedBtnE2028Set();
	afx_msg void OnBnClickedBtnE2045Set();
};
UINT EventThread_( LPVOID param );